#!/usr/bin/python
import os, struct

class hex:
	def __init__(self,name,offset,len,val):
		self.name=name
		self.len=len
		self.val=val
	def mkbinary(self,newval):
		if self.len == 1:
			return struct.pack("B",newval)
		if self.len == 2:
			return struct.pack("H",newval)
		if self.len == 4:
			return struct.pack("I",newval)
		raise ValueError
	def mkprintable(self):
		if self.len == 1:
			return struct.unpack("B",self.val)[0]
		if self.len == 2:
			return struct.unpack("H",self.val)[0]
		if self.len == 4:
			return struct.unpack("I",self.val)[0]
		raise ValueError
	def display(self):
		fs="%%s: 0x%%0%uX (%%u)"%(2*self.len)
		hex=self.mkprintable()
		if self.len==4:
			down=hex&0xffff
			up=hex>>16
			#print up,down
			print "%s: 0x%04x%04x (%u,%u)"%(self.name,up,down,up,down)
			return
		print fs%(self.name,hex,hex)
	def update(self,fd,baseoff,newval):
		print "NOT updating %s"%self.name
		self.val=newval
		return
		os.lseek(fd,baseoff+self.offset,0)
		os.write(fd,self.mkbinary(newval))


class name(hex):
	def mkbinary(self,newval):
		formatstring="%%%us"%self.len
		return struct.pack(formatstring,newval)
	def mkprintable(self):
		formatstring="%us"%self.len
#		print "formatstring=%s, len=%u"%(formatstring,len(self.val))
		return struct.unpack(formatstring,self.val)[0]
	def display(self):
		print "%s: %s"%(self.name,self.mkprintable())


class disk_struct:
	def __init__(self,fd,offset,table):
		self.data=[]
		self.fd=fd
		self.offset=offset
		os.lseek(fd,offset,0)
		myoff=0
		for row in table:
			(name,len,type)=row
			data=os.read(fd,len)
			self.data.append(type(name,myoff,len,data))
			myoff=myoff+len
	def display(self):
		for record in self.data:
			record.display()
	def _search(self,x):
		return x.name==self.nam
	def get_val(self,name):
		return self.getnamed(name).mkprintable()
	def getnamed(self,nam):
		self.nam=nam
		index=map(self._search,self.data).index(1)
		return self.data[index]
	def update(self,name,value):
		record=self.getnamed(name)
		record.update(self.fd,self.offset,value)

